#include <iostream>
#include <iomanip>
#include <error.h>
#include <matutil.h>
#include <derint.h>

inline double F(double x)
{
  return x*exp(x - 10.);
}
//Declaracion de la funcion
double simp(func F, double a, double b, int n);
double trap(func F,double a,double b,int n);
//Definicion de la funcion
double simp(func F, double a, double b, int n){
double h=(b-a)/n;
double m=n/2;
double l;
for (int i=1;i<=m;i++){
l +=F(a+(2*i-2)*h)+4*F(a+(2*i-1)*h)+F(a+2*i*h);
}
double j=h*0.33*l;
return j;
}
double trap(func F, double a, double b, int n){
double h=(b-a)/(pow (2.,n));
double fa=F(a);
double fb=F(b);
double l;
double m=pow(2.,n)-1;

for (int i=1;i<=m;i++){
l +=F(a+i*h);
}
double j=0.5*h+h*l;
    return j;
}
int main ()
{
    double a;
    double b;
    int n;
    cout <<"Este programa calcula el valor de la integral de una funcion F(x) en un intrvalo [a,b] utilizando"<<endl;
    cout <<"el metodo de Simpson(para n intervalos donde n es par) y la regla trapezoidal para 2**n intervalos."<<endl;
    cout <<"Elegimos los limites del intervalo [a,b];"<<endl;
    cout <<"Intruduce el limite inferior a="<<endl;
    cin >> a;
    cout <<"Introduce el limite superior b="<<endl;
    cin >> b;
    cout <<"Ahora elegiremos n(un n par!);"<<endl;
    cin >>n;
    double Intes=simp(F, a, b, n);
    double Intet= trap(F, a, b, n);
    cout <<"El valor de la integral utilizando el metodo de Simpson es I="<< Intes <<endl;
    cout <<"El valor de la integral utilizando la regla trapezoidal recursiva es I="<< Intes <<endl;
    return 0;
}





