#include <iostream>
#include <iomanip>
#include <error.h>
#include <matutil.h>
#include <derint.h>

inline double F(double x)
{
  return x*exp(x-10.);
}
//Declaracion de la funcion
double trap(func F,double a,double b,int n);
//Definicion de la funcion
double trap(func F, double a, double b, int n){
double h=(b-a)/(pow (2.,n));
double fa=F(a);
double fb=F(b);
double l;
double m=pow(2.,n)-1;

for (int i=1;i<=m;i++){
l +=F(a+i*h);
}
double j=0.5*h+h*l;
    return j;
}

int main ()
{
double a;
double b;
int n;


    cout << "Este rograma calcula el valor de la integral definida en un intervalo [a,b] de una funcion F" << endl;
    cout << "utlizando la regla trapezoidal recursiva para 2**n intervalos."<<endl;
    cout <<"Intruduce el limite inferior a="<<endl;
    cin >> a;
    cout <<"Introduce el limite superior b="<<endl;
    cin >> b;
    cout <<"Introduce el numero n,el programa dividira el intervalo en 2**n subintervalos iguales."<<endl;
    cin >> n;
    double Inte = trap(F, a, b, n);
    cout <<"El valor de la integral es I="<< Inte <<endl;

    return 0;
}





